/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.openzen.javascriptingexample;

import java.io.File;
import java.util.Optional;
import org.openzen.zencode.java.JavaNativeModule;
import org.openzen.zencode.java.ScriptingEngine;
import org.openzen.zencode.shared.CompileException;
import org.openzen.zencode.shared.FileSourceFile;
import org.openzen.zencode.shared.SourceFile;
import org.openzen.zenscript.codemodel.SemanticModule;
import org.openzen.zenscript.lexer.ParseException;

/**
 *
 * @author Hoofdgebruiker
 */
public class Main {
	public static void main(String[] args) throws CompileException, ParseException {
		ScriptingEngine engine = new ScriptingEngine();
		
		// The name of the module can be freely chosen (but make sure it matches the dependency name below)
		// The name of the base package MUST match with the package of the classes that will be registered below
		JavaNativeModule example = engine.createNativeModule("example", "org.openzen.javascriptingexample");
		example.addGlobals(Globals.class);
		example.addClass(TestClass.class);
		engine.registerNativeProvided(example);
		
		File inputDirectory = new File("scripts");
		File[] inputFiles = Optional.ofNullable(inputDirectory.listFiles((dir, name) -> name.endsWith(".zs"))).orElseGet(() -> new File[0]);
		SourceFile[] sourceFiles = new SourceFile[inputFiles.length];
		for (int i = 0; i < inputFiles.length; i++)
			sourceFiles[i] = new FileSourceFile(inputFiles[i].getName(), inputFiles[i]);
		
		SemanticModule scripts = engine.createScriptedModule("scripts", sourceFiles, "example");
		if (!scripts.isValid())
			return;
		
		engine.registerCompiled(scripts);
		engine.run();
	}
}
